/*
 * Arduino.cpp
 *
 *  Created on: 02 mar 2017
 *      Author: Francesco Gatto
 */

#include <stdio.h>

#include "Arduino.h"

#ifdef _WIN32
#include <windows.h>

// Console mapped to default stdin/stdout
Serial tty(GetStdHandle(STD_INPUT_HANDLE), GetStdHandle(STD_OUTPUT_HANDLE));
// Change COM Port number for USB/Serial adapter (system dependent)!
Serial serial("\\\\.\\COM90");

#else
#include <sys/time.h>
#include <unistd.h>

// Console mapped to default stdin/stdout
Serial tty(0, 1);
// Map serial port to platform specific device
#if RASPBERRY
Serial serial("/dev/ttyAMA0");
#elif BEAGLEBONE
Serial serial("/dev/ttyO1");
#else //DESKTOP
// Change device for USB/Serial adapter (system dependent)!
Serial serial("/dev/ttyUSB0");
#endif
#endif

void setup();
void loop();

int main(int argc, char* argv[])
{
	setup();
	for (;;)
		loop();
	return 0;
}

void delay(int ms)
{
#ifdef _WIN32
	Sleep(ms);
#else
	usleep(ms * 1000);
#endif
}

uint32_t millis()
{
#ifdef _WIN32
	return GetTickCount();
#else
	struct timeval tv =
	{ 0, 0 };
	gettimeofday(&tv, NULL);
	return (uint32_t) (tv.tv_sec * 1000 + tv.tv_usec / 1000);
#endif
}
