/*
 * Print.cpp
 *
 *  Created on: 03 mar 2017
 *      Author: Francesco Gatto
 */

#include "Arduino.h"

Print::Print()
{
}

Print::~Print()
{
}

size_t Print::write(const uint8_t *buffer, size_t size)
{
  size_t n = 0;
  while (size--) {
    if (write(*buffer++)) n++;
    else break;
  }
  return n;
}

size_t Print::print(const char* s)
{
	size_t n = strlen(s);
	return write((const uint8_t *)s, n);
}

size_t Print::print(int n, int t)
{
	char buf[20];
	int ret = 0;
	if (t == DEC)
		ret = snprintf(buf, sizeof(buf), "%i", n);
	if (t == HEX)
		ret = snprintf(buf, sizeof(buf), "%x", n);
	if (ret > 0)
		write((const uint8_t *)buf, ret);
	return ret;
}

size_t Print::print(unsigned int n, int t)
{
	char buf[20];
	int ret = 0;
	if (t == DEC)
		ret = snprintf(buf, sizeof(buf), "%u", n);
	if (t == HEX)
		ret = snprintf(buf, sizeof(buf), "%x", n);
	if (ret > 0)
		write((const uint8_t *)buf, ret);
	return ret;
}

size_t Print::println(const char* s)
{
	size_t n = strlen(s);
	return write((const uint8_t *)s, n) + write('\n');
}

size_t Print::println(int n, int t)
{
	char buf[20];
	int ret = 0;
	if (t == DEC)
		ret = snprintf(buf, sizeof(buf), "%i\n", n);
	if (t == HEX)
		ret = snprintf(buf, sizeof(buf), "%x\n", n);
	if (ret > 0)
		write((const uint8_t *)buf, ret);
	return ret;
}

size_t Print::println(unsigned int n, int t)
{
	char buf[20];
	int ret = 0;
	if (t == DEC)
		ret = snprintf(buf, sizeof(buf), "%u\n", n);
	if (t == HEX)
		ret = snprintf(buf, sizeof(buf), "%x\n", n);
	if (ret > 0)
		write((const uint8_t *)buf, ret);
	return ret;
}
