/*
 * Print.h
 *
 *  Created on: 03 mar 2017
 *      Author: Francesco Gatto
 */

#ifndef PRINT_H_
#define PRINT_H_

#include "Arduino.h"

enum
{
	DEC, HEX
};

class Print
{
protected:
	Print();
	virtual ~Print();

public:
	virtual size_t write(uint8_t) = 0;
	size_t write(const char *str)
	{
		if (str == NULL)
			return 0;
		return write((const uint8_t *) str, strlen(str));
	}
	virtual size_t write(const uint8_t *buffer, size_t size);
	size_t write(const char *buffer, size_t size)
	{
		return write((const uint8_t *) buffer, size);
	}

	size_t print(const char*);
	size_t print(int, int = DEC);
	size_t print(unsigned int, int = DEC);

	size_t println(const char* = "");
	size_t println(int, int = DEC);
	size_t println(unsigned int, int = DEC);
};

#endif /* PRINT_H_ */
