/*
 * Serial.h
 *
 *  Created on: 01 mar 2017
 *      Author: Francesco Gatto
 */

#ifndef SERIAL_H_
#define SERIAL_H_

#include "Arduino.h"

class Serial: public Stream
{
private:
#ifdef _WIN32
	HANDLE hIn, hOut;
	bool bConsole, bPipe;
#else
	int fdIn, fdOut;
#endif

public:
#ifdef _WIN32
	Serial(HANDLE in, HANDLE out);
#else
  Serial(int in, int out);
#endif
	Serial(const char* portName);
	virtual ~Serial();

	void begin(unsigned long baud);
	void end();

	virtual int available();
	virtual int read();
	virtual void flush();
	virtual size_t write(uint8_t);
	using Print::write; // pull in write(str) and write(buf, size) from Print
};

#endif /* SERIAL_H_ */
